<?php

namespace InSegment\WorkersFramework\Providers;

use Shavshukov\EventAppBase\Service\Provider;
use Shavshukov\EventAppBase\Service\Container;
use React\Promise;
use InSegment\WorkersFramework\Services\WorkerGc;

class LockfileServiceProvider extends Provider
{

    /**
     * {@inheritDoc}
     */
    public function register(Container $container, ...$registerArguments)
    {
        $container->bind('lockfile-writable-stream', function () {
            return $this->openStream();
        }, true);
    }

    /**
     * Invoke connectors to establish connections
     * 
     * @return \InSegment\WorkersFramework\Interfaces\LockfileInterface<\InSegment\WorkersFramework\Services\WorkerGc>
     */
    protected function openStream(): \InSegment\WorkersFramework\Interfaces\LockfileInterface
    {
        $app = $this->app;
        return Promise\all(function () use ($app) {
            return new WorkerGc($app);
        });
    }
}
